//////////////////////////////////////////////////////////////////////////
//	"socklib.h"
#ifndef	SOCKLIB_H_INCLUDED
#define	SOCKLIB_H_INCLUDED

#ifndef	WIN32_LEAN_AND_MEAN
# define WIN32_LEAN_AND_MEAN
#endif
#include <winsock2.h>

class	SockLib
{
public:
	class SockAddr
	{
	public:
		struct sockaddr_in	sockaddr;
		SockAddr();

		void		SetAddr(unsigned long addr) { this->sockaddr.sin_addr.s_addr = ::htonl(addr); }
		void		SetPort(unsigned port) { this->sockaddr.sin_port = ::htons(port); }
		int			SetAddr(unsigned long addr, unsigned port);
		int			SockAddr::SetAddr(const char * s);
	};
	enum	socklib_flag_enum
	{
		F_SOCKET     = 0x0001,
	};

private:
	static int			sockCount;
	static BOOL			wsaStartup;
	static WORD			sockVer;
	static WSADATA		wsaData;

 	unsigned			flags;
	SOCKET				conn_socket;
	int					socket_type;

public:
	SockLib();
	~SockLib();

	int			IsCreate(void) { return (this->flags & F_SOCKET) ? TRUE : FALSE; }
	SOCKET		GetSocket(void) const { return this->conn_socket; }
	int			Create(int type);
	int			Close(void);
	int			SetSocket(SOCKET socket);
	int			GetSockOpt(int level, int optname, void * optval, int * optlen);
	int			SetSockOpt(int level, int optname, void * optval, int optlen);
	int			Connect(SockAddr & addr);
	int			Bind(SockAddr & addr);
	int			Listen(int backlog);
	int			Accept(SockLib * socklib, SockAddr & addr);
	int			Send(unsigned size, const void * buffer, int flag);
	int			SendTo(unsigned size, const void * buffer, int flag, SockLib::SockAddr & toaddr);
	int			Recv(unsigned size, void * buffer, int flag);
	int			RecvFrom(unsigned size, void * buffer, int flag, SockAddr & from);
};


#endif
